diff --git a/chrome/test/chromedriver/test/run_py_tests.py b/chrome/test/chromedriver/test/run_py_tests.py
index 6da715856ce6c..49d8ed60aef18 100755
--- a/chrome/test/chromedriver/test/run_py_tests.py
+++ b/chrome/test/chromedriver/test/run_py_tests.py
@@ -127,6 +127,89 @@ _OS_SPECIFIC_FILTER['win'] = [
     'ChromeDriverTest.testTakeElementScreenshotInIframe',
 ]
 _OS_SPECIFIC_FILTER['linux'] = [
+    # Unable to simulate input event on Qt dialog
+    'ChromeDesiredCapabilityTest.testUnexpectedAlertBehaviour',
+    'ChromeDesiredCapabilityTest.testUnexpectedAlertBehaviourLegacy',
+    'ChromeDesiredCapabilityTest.testUnexpectedAlertBehaviourW3c',
+    'ChromeDriverTest.testAlert',
+    'ChromeDriverTest.testClickElementAfterNavigation',
+    'ChromeDriverTest.testGetLogOnWindowWithAlert',
+    'ChromeDriverTest.testSendTextToAlert',
+    'ChromeDriverTestLegacy.testDragAndDropWithSVGImage',
+    'ChromeDriverTestLegacy.testUnexpectedAlertOpenExceptionMessage',
+    'ChromeDriverW3cTest.testUnexpectedAlertOpenExceptionMessage',
+    # Headless mode doesn't work
+    'HeadlessChromeDriverTest.*',
+    # exceptions.UnknownCommand: unknown command: 'Browser.getWindowForTarget' wasn't found
+    'ChromeDriverTest.testClickElementAlmostObscuredByScrollBar',
+    'ChromeDriverTest.testClickElementHavingSmallIntersectionWithindowObscuredByScrollBar',
+    'ChromeDriverTest.testClickElementObscuredByScrollBar',
+    'ChromeDriverTest.testTakeElementScreenshotPartlyVisible',
+    'ChromeDriverTest.testTakeLargeElementScreenshot',
+    'ChromeDriverTest.testTakeLargeElementViewportScreenshot',
+    'ChromeDriverTest.testWindowFullScreen',
+    'ChromeDriverTest.testWindowMaximize',
+    'ChromeDriverTest.testWindowMinimize',
+    'ChromeDriverTest.testWindowPosition',
+    'ChromeDriverTest.testWindowRect',
+    'ChromeDriverTest.testWindowSize',
+    'JavaScriptTests.testAllJS',
+    # exceptions.NoSuchWindow: no such window
+    'BidiTest.*',
+    'ChromeDriverTest.testNewTabDoesNotFocus',
+    'ChromeDriverTest.testNewWindowDoesNotFocus',
+    'ChromeDriverTest.testNewWindowSameDomainHasSamePermissions',
+    'ChromeDriverTest.testPermissionsSameOrigin',
+    'ChromeDriverTest.testPermissionsSameOriginDoesNotAffectOthers',
+    'ChromeDriverWebSocketTest.testWebSocketClosedCanReconnect',
+    'ChromeDriverWebSocketTest.testWebSocketInvalidSessionId',
+    'ChromeDriverWebSocketTest.testWebSocketOneConnectionPerSession',
+    'ChromeDriverWebSocketTest.testWebSocketUrlTrue',
+    # exceptions.UnknownError: unknown error: Shadow not found in fenced frame
+    'ChromeDriverFencedFrame.*',
+    # exceptions.UnknownError: unknown error: net::ERR_NAME_NOT_RESOLVED
+    'ChromeDriverPageLoadTimeoutTest.testPageLoadTimeoutCrossDomain',
+    'ChromeDriverSecureContextTest.testAddCredential',
+    'ChromeDriverSecureContextTest.testAddCredentialLargeBlob',
+    'ChromeDriverSecureContextTest.testAddVirtualAuthenticator',
+    'ChromeDriverSecureContextTest.testAddVirtualAuthenticatorDefaultParams',
+    'ChromeDriverSecureContextTest.testAddVirtualAuthenticatorProtocolVersion',
+    'ChromeDriverSecureContextTest.testGetCredentials',
+    'ChromeDriverSecureContextTest.testRemoveAllCredentials',
+    'ChromeDriverSecureContextTest.testRemoveCredential',
+    'ChromeDriverSecureContextTest.testRemoveVirtualAuthenticator',
+    'ChromeDriverSecureContextTest.testSetUserVerified',
+    'ChromeDriverSecureContextTest.testAddCredentialBase64Errors',
+    # no such element: Unable to locate element: {"method":"css selector","selector":...}
+    'ChromeDriverTest.testCanClickAlertInIframes',
+    'ChromeDriverTest.testCanClickInIframesInShadow',
+    'ChromeDriverTest.testCanClickInIframesInShadowScrolled',
+    'ChromeDriverTest.testClickElementThatRestartsBrowser',
+    # unhandled inspector error: {"code":-32000,"message":"Browser context management is not supported."}
+    'ChromeDriverTest.testMidiPermissions',
+    'ChromeDriverTest.testMultiplePermissions',
+    'ChromeDriverTest.testPermissionStates',
+    'ChromeDriverTest.testPermissionsOpaqueOriginsThrowError',
+    'ChromeDriverTest.testPersistentStoragePermissions',
+    'ChromeDriverTest.testPushAndNotificationsPermissions',
+    'ChromeDriverTest.testSensorPermissions',
+    'ChromeDriverTest.testSettingPermissionDoesNotAffectOthers',
+    # FAILURES (QtWebEngine behavior differs compared to Chrome)
+    'ChromeDriverTest.testActionsMulti',
+    'ChromeDriverTest.testActionsPause',
+    'ChromeDriverTest.testAlertHandlingOnPageUnload',
+    'ChromeDriverTest.testCanSwitchToPrintPreviewDialog',
+    'ChromeDriverTest.testClipboardPermissions',
+    'ChromeDriverTest.testReleaseActions',
+    'ChromeDriverTest.testWaitForCurrentFrameToLoad',
+    'ChromeDriverTestLegacy.testSendKeysToElement',
+    'ChromeDriverTestLegacy.testSendingTabKeyMovesToNextInputElement',
+    'ChromeDriverW3cTest.testSendKeysToElement',
+    'LaunchDesktopTest.testHelpfulErrorMessage_NormalExit',
+    # KNOWN UNSUPPORTED FEATURES
+    'LaunchDesktopTest.testExistingDevToolsPortFile',
+    'ChromeLogPathCapabilityTest.testChromeLogPath',
+    'ChromeDownloadDirTest.*',
 ]
 _OS_SPECIFIC_FILTER['mac'] = [
     # https://bugs.chromium.org/p/chromium/issues/detail?id=1011225