diff --git a/src/libs/installer/binaryformat.cpp b/src/libs/installer/binaryformat.cpp
index 59cc5fb4..ad80ba7b 100644
--- a/src/libs/installer/binaryformat.cpp
+++ b/src/libs/installer/binaryformat.cpp
@@ -153,7 +153,7 @@ void Resource::setName(const QByteArray &name)
     Opens a resource in QIODevice::ReadOnly mode. The function returns \c true
     if successful.
 */
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
 bool Resource::open()
 #else
 bool Resource::open(std::optional<QFile::Permissions> permissions)
@@ -161,7 +161,7 @@ bool Resource::open(std::optional<QFile::Permissions> permissions)
 {
     if (isOpen())
         return false;
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
     if (!m_file.open(QIODevice::ReadOnly | QIODevice::Unbuffered)) {
 #else
     if (!m_file.open(QIODevice::ReadOnly | QIODevice::Unbuffered, permissions)) {
diff --git a/src/libs/installer/binaryformat.h b/src/libs/installer/binaryformat.h
index fa1becc3..e7505a34 100644
--- a/src/libs/installer/binaryformat.h
+++ b/src/libs/installer/binaryformat.h
@@ -58,7 +58,7 @@ public:
     Resource(const QString &path, const Range<qint64> &segment);
     ~Resource();
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
     bool open();
 #else
     bool open(std::optional<QFile::Permissions> permissions = std::nullopt);
diff --git a/src/libs/installer/binaryformatengine.cpp b/src/libs/installer/binaryformatengine.cpp
index 8aa8cdca..7f00c8d4 100644
--- a/src/libs/installer/binaryformatengine.cpp
+++ b/src/libs/installer/binaryformatengine.cpp
@@ -127,14 +127,14 @@ bool BinaryFormatEngine::close()
 /*!
     \internal
 */
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
 bool BinaryFormatEngine::open(QIODevice::OpenMode mode)
 #else
 bool BinaryFormatEngine::open(QIODevice::OpenMode mode, std::optional<QFile::Permissions> permissions)
 #endif
 {
     Q_UNUSED(mode)
-#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION >= QT_VERSION_CHECK(6, 3, 0)
     Q_UNUSED(permissions)
 #endif
     return m_resource.isNull() ? false : m_resource->open();
diff --git a/src/libs/installer/binaryformatengine.h b/src/libs/installer/binaryformatengine.h
index 169bfe0f..9321e9d9 100644
--- a/src/libs/installer/binaryformatengine.h
+++ b/src/libs/installer/binaryformatengine.h
@@ -47,7 +47,7 @@ public:
 
     bool copy(const QString &newName) override;
     bool close() override;
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
     bool open(QIODevice::OpenMode mode) override;
 #else
     bool open(QIODevice::OpenMode mode,
diff --git a/src/libs/installer/qsettingswrapper.cpp b/src/libs/installer/qsettingswrapper.cpp
index 76b73a67..d322728f 100644
--- a/src/libs/installer/qsettingswrapper.cpp
+++ b/src/libs/installer/qsettingswrapper.cpp
@@ -141,7 +141,7 @@ QString QSettingsWrapper::applicationName() const
     return d->settings.applicationName();
 }
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
     void QSettingsWrapper::beginGroup(const QString &prefix)
 #else
     void QSettingsWrapper::beginGroup(QAnyStringView prefix)
@@ -153,7 +153,7 @@ QString QSettingsWrapper::applicationName() const
         d->settings.beginGroup(prefix);
 }
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
     int QSettingsWrapper::beginReadArray(const QString &prefix)
 #else
     int QSettingsWrapper::beginReadArray(QAnyStringView prefix)
@@ -164,7 +164,7 @@ QString QSettingsWrapper::applicationName() const
     return d->settings.beginReadArray(prefix);
 }
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
     void QSettingsWrapper::beginWriteArray(const QString &prefix, int size)
 #else
     void QSettingsWrapper::beginWriteArray(QAnyStringView prefix, int size)
@@ -197,7 +197,7 @@ void QSettingsWrapper::clear()
     else d->settings.clear();
 }
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
     bool QSettingsWrapper::contains(const QString &key) const
 #else
     bool QSettingsWrapper::contains(QAnyStringView key) const
@@ -265,7 +265,7 @@ QString QSettingsWrapper::organizationName() const
     return d->settings.organizationName();
 }
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
     void QSettingsWrapper::remove(const QString &key)
 #else
     void QSettingsWrapper::remove(QAnyStringView key)
@@ -298,7 +298,7 @@ void QSettingsWrapper::setFallbacksEnabled(bool param1)
     else
         d->settings.setFallbacksEnabled(param1);
 }
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
 void QSettingsWrapper::setValue(const QString &key, const QVariant &value)
 #else
 void QSettingsWrapper::setValue(QAnyStringView key, const QVariant &value)
@@ -327,7 +327,7 @@ void QSettingsWrapper::sync()
         d->settings.sync();
 }
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
 QVariant QSettingsWrapper::value(const QString &key, const QVariant &value) const
 #else
 QVariant QSettingsWrapper::value(QAnyStringView key, const QVariant &value) const
@@ -338,7 +338,7 @@ QVariant QSettingsWrapper::value(QAnyStringView key, const QVariant &value) cons
     return d->settings.value(key, value);
 }
 
-#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION >= QT_VERSION_CHECK(6, 4, 0)
 QVariant QSettingsWrapper::value(QAnyStringView key) const
 {
     if (createSocket())
diff --git a/src/libs/installer/qsettingswrapper.h b/src/libs/installer/qsettingswrapper.h
index b50e4622..f5d428b1 100644
--- a/src/libs/installer/qsettingswrapper.h
+++ b/src/libs/installer/qsettingswrapper.h
@@ -70,7 +70,7 @@ public:
     void sync();
     Status status() const;
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
     void beginGroup(const QString &prefix);
 #else
     void beginGroup(QAnyStringView prefix);
@@ -78,7 +78,7 @@ public:
     void endGroup();
     QString group() const;
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
     int beginReadArray(const QString &prefix);
     void beginWriteArray(const QString &prefix, int size = -1);
 #else
@@ -93,7 +93,7 @@ public:
     QStringList childGroups() const;
     bool isWritable() const;
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
     void setValue(const QString &key, const QVariant &value);
     QVariant value(const QString &key, const QVariant &defaultValue = QVariant()) const;
 #else
@@ -102,7 +102,7 @@ public:
     QVariant value(QAnyStringView key) const;
 #endif
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
     void remove(const QString &key);
     bool contains(const QString &key) const;
 #else
@@ -126,7 +126,7 @@ private: // we cannot support the following functionality
         : RemoteObject(QLatin1String(Protocol::QSettings), parent)
     {}
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 4, 0)
     void setIniCodec(QTextCodec * /*codec*/);
     void setIniCodec(const char * /*codecName*/);
     QTextCodec *iniCodec() const { return 0; }
diff --git a/src/libs/installer/remotefileengine.cpp b/src/libs/installer/remotefileengine.cpp
index c2dd1443..7a5e9168 100644
--- a/src/libs/installer/remotefileengine.cpp
+++ b/src/libs/installer/remotefileengine.cpp
@@ -313,7 +313,7 @@ bool RemoteFileEngine::link(const QString &newName)
 /*!
     \reimp
 */
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
 bool RemoteFileEngine::mkdir(const QString &dirName, bool createParentDirectories) const
 {
     if ((const_cast<RemoteFileEngine *>(this))->connectToServer()) {
@@ -338,7 +338,7 @@ bool RemoteFileEngine::mkdir(const QString &dirName, bool createParentDirectorie
 /*!
     \reimp
 */
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
 bool RemoteFileEngine::open(QIODevice::OpenMode mode)
 #else
 bool RemoteFileEngine::open(QIODevice::OpenMode mode, std::optional<QFile::Permissions> permissions)
@@ -348,7 +348,7 @@ bool RemoteFileEngine::open(QIODevice::OpenMode mode, std::optional<QFile::Permi
         return callRemoteMethod<bool>(QString::fromLatin1(Protocol::QAbstractFileEngineOpen),
             static_cast<qint32>(mode | QIODevice::Unbuffered));
     }
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
     return m_fileEngine.open(mode | QIODevice::Unbuffered);
 #else
     return m_fileEngine.open(mode | QIODevice::Unbuffered, permissions);
diff --git a/src/libs/installer/remotefileengine.h b/src/libs/installer/remotefileengine.h
index 6227a044..31ae67d7 100644
--- a/src/libs/installer/remotefileengine.h
+++ b/src/libs/installer/remotefileengine.h
@@ -53,7 +53,7 @@ public:
     RemoteFileEngine();
     ~RemoteFileEngine();
 
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
     bool open(QIODevice::OpenMode mode) override;
 #else
     bool open(QIODevice::OpenMode mode,
@@ -71,7 +71,7 @@ public:
     bool rename(const QString &newName) override;
     bool renameOverwrite(const QString &newName) override;
     bool link(const QString &newName) override;
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
     bool mkdir(const QString &dirName, bool createParentDirectories) const override;
 #else
     bool mkdir(const QString &dirName, bool createParentDirectories,
diff --git a/src/libs/installer/remoteserverconnection.cpp b/src/libs/installer/remoteserverconnection.cpp
index 9a80637f..51619983 100644
--- a/src/libs/installer/remoteserverconnection.cpp
+++ b/src/libs/installer/remoteserverconnection.cpp
@@ -498,7 +498,7 @@ void RemoteServerConnection::handleQFSFileEngine(RemoteServerReply *reply, const
         bool createParentDirectories;
         data >>dirName;
         data >>createParentDirectories;
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
         reply->send(m_engine->mkdir(dirName, createParentDirectories));
 #else
         reply->send(m_engine->mkdir(dirName, createParentDirectories, std::nullopt));
@@ -507,7 +507,7 @@ void RemoteServerConnection::handleQFSFileEngine(RemoteServerReply *reply, const
     } else if (command == QLatin1String(Protocol::QAbstractFileEngineOpen)) {
         qint32 openMode;
         data >>openMode;
-#if QT_VERSION < QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION < QT_VERSION_CHECK(6, 3, 0)
         reply->send(m_engine->open(static_cast<QIODevice::OpenMode> (openMode)));
 #else
         reply->send(m_engine->open(static_cast<QIODevice::OpenMode> (openMode), std::nullopt));
diff --git a/src/sdk/sdkapp.h b/src/sdk/sdkapp.h
index 8ef6440f..07628ade 100644
--- a/src/sdk/sdkapp.h
+++ b/src/sdk/sdkapp.h
@@ -75,7 +75,7 @@ public:
         , m_core(nullptr)
     {
         m_parser.parse(QCoreApplication::arguments());
-#if QT_VERSION >= QT_VERSION_CHECK(6, 0, 0)
+#if QT_VERSION >= QT_VERSION_CHECK(6, 4, 0)
         QNetworkInformation::loadDefaultBackend();
 #endif
     }
diff --git a/tools/binarycreator/binarycreator.pro b/tools/binarycreator/binarycreator.pro
index b2e8c68b..a51f0bcc 100644
--- a/tools/binarycreator/binarycreator.pro
+++ b/tools/binarycreator/binarycreator.pro
@@ -6,6 +6,7 @@ include(../../installerfw.pri)
 
 QT -= gui
 QT += qml xml concurrent
+greaterThan(QT_MAJOR_VERSION, 5):QT += core5compat
 
 CONFIG += console
 DESTDIR = $$IFW_APP_PATH
diff --git a/tools/devtool/devtool.pro b/tools/devtool/devtool.pro
index def7066a..69f60dd5 100644
--- a/tools/devtool/devtool.pro
+++ b/tools/devtool/devtool.pro
@@ -2,6 +2,7 @@ TEMPLATE = app
 TARGET = devtool
 
 QT = core network qml xml concurrent
+greaterThan(QT_MAJOR_VERSION, 5):QT += core5compat
 
 include(../../installerfw.pri)
 
diff --git a/tools/repogen/repogen.pro b/tools/repogen/repogen.pro
index 73f1eafe..cf796c40 100644
--- a/tools/repogen/repogen.pro
+++ b/tools/repogen/repogen.pro
@@ -6,6 +6,7 @@ include(../../installerfw.pri)
 
 QT -= gui
 QT += qml xml concurrent
+greaterThan(QT_MAJOR_VERSION, 5):QT += core5compat
 
 CONFIG -= import_plugins
 