diff --git a/src/assistant/qlitehtml b/src/assistant/qlitehtml
index f05f78ef3..4931b7aa3 160000
--- a/src/assistant/qlitehtml
+++ b/src/assistant/qlitehtml
@@ -1 +1 @@
-Subproject commit f05f78ef33225823d348ee18f2fa464e95024dd2
+Subproject commit 4931b7aa30f256c20573d283561aa432fecf8f38
diff --git a/src/designer/src/components/formeditor/qdesigner_resource.cpp b/src/designer/src/components/formeditor/qdesigner_resource.cpp
index 213645e39..d03e8c62e 100644
--- a/src/designer/src/components/formeditor/qdesigner_resource.cpp
+++ b/src/designer/src/components/formeditor/qdesigner_resource.cpp
@@ -170,8 +170,10 @@ QVariant QDesignerResourceBuilder::loadResource(const QDir &workingDirectory, co
         case DomProperty::IconSet: {
             PropertySheetIconValue icon;
             DomResourceIcon *di = property->elementIconSet();
+            qDebug() << "QDesignerResourceBuilder::loadResource" <<  di->attributeTheme();
             icon.setTheme(di->attributeTheme());
             if (const int flags = iconStateFlags(di)) { // new, post 4.4 format
+                qDebug() << "QDesignerResourceBuilder::loadResource" << Qt::hex << flags;
                 if (flags & NormalOff)
                     setIconPixmap(QIcon::Normal, QIcon::Off, workingDirectory, di->elementNormalOff()->text(), icon, m_lang);
                 if (flags & NormalOn)
@@ -189,12 +191,15 @@ QVariant QDesignerResourceBuilder::loadResource(const QDir &workingDirectory, co
                 if (flags & SelectedOn)
                     setIconPixmap(QIcon::Selected, QIcon::On, workingDirectory, di->elementSelectedOn()->text(), icon, m_lang);
             } else {
+
 #ifdef OLD_RESOURCE_FORMAT
+                qDebug() << "QDesignerResourceBuilder::loadResource 4.3";
                 setIconPixmap(QIcon::Normal, QIcon::Off, workingDirectory, di->text(), icon, m_lang);
                 if (di->hasAttributeResource())
                     m_loadedQrcFiles.insert(QFileInfo(workingDirectory, di->attributeResource()).absoluteFilePath(), false);
 #endif
             }
+            qDebug() << "QDesignerResourceBuilder::loadResource fallthrough";
             return QVariant::fromValue(icon);
         }
         default:
diff --git a/src/designer/src/lib/uilib/resourcebuilder.cpp b/src/designer/src/lib/uilib/resourcebuilder.cpp
index 7b06a2e21..56d0e8a5d 100644
--- a/src/designer/src/lib/uilib/resourcebuilder.cpp
+++ b/src/designer/src/lib/uilib/resourcebuilder.cpp
@@ -16,7 +16,7 @@ QT_BEGIN_NAMESPACE
 namespace QFormInternal {
 #endif
 
-enum { themeDebug = 0 };
+enum { themeDebug = 1 };
 
 QResourceBuilder::QResourceBuilder() = default;
 
@@ -54,6 +54,7 @@ QVariant QResourceBuilder::loadResource(const QDir &workingDirectory, const DomP
         }
         case DomProperty::IconSet: {
             const DomResourceIcon *dpi = property->elementIconSet();
+            qDebug() << "QResourceBuilder::loadResource" <<  dpi->attributeTheme();
             if (!dpi->attributeTheme().isEmpty()) {
                 const QString theme = dpi->attributeTheme();
                 const bool known = QIcon::hasThemeIcon(theme);
@@ -63,6 +64,7 @@ QVariant QResourceBuilder::loadResource(const QDir &workingDirectory, const DomP
                     return QVariant::fromValue(QIcon::fromTheme(dpi->attributeTheme()));
             } // non-empty theme
             if (const int flags = iconStateFlags(dpi)) { // new, post 4.4 format
+                qDebug() <<  "QResourceBuilder::loadResource" <<  Qt::hex << "0x" << flags;
                 QIcon icon;
                 if (flags & NormalOff)
                     icon.addFile(QFileInfo(workingDirectory, dpi->elementNormalOff()->text()).absoluteFilePath(), QSize(), QIcon::Normal, QIcon::Off);
@@ -82,6 +84,7 @@ QVariant QResourceBuilder::loadResource(const QDir &workingDirectory, const DomP
                     icon.addFile(QFileInfo(workingDirectory, dpi->elementSelectedOn()->text()).absoluteFilePath(), QSize(), QIcon::Selected, QIcon::On);
                 return QVariant::fromValue(icon);
             } else { // 4.3 legacy
+                qDebug() <<  "QResourceBuilder::loadResource" << "4.3 fallback";
                 const QIcon icon(QFileInfo(workingDirectory, dpi->text()).absoluteFilePath());
                 return QVariant::fromValue(icon);
             }