diff --git a/sources/pyside6/PySide6/glue/qtcore.cpp b/sources/pyside6/PySide6/glue/qtcore.cpp
index 82d2921e3..12fa07491 100644
--- a/sources/pyside6/PySide6/glue/qtcore.cpp
+++ b/sources/pyside6/PySide6/glue/qtcore.cpp
@@ -1433,6 +1433,7 @@ if (metaType.isValid()) {
 
 // @snippet conversion-pydict
 QVariant ret = QVariant_convertToVariantMap(%in);
+qDebug() << "conversion-pydict" << %in << ret;
 %out = ret.isValid() ? ret : QVariant::fromValue(PySide::PyObjectWrapper(%in));
 // @snippet conversion-pydict
 
@@ -1536,6 +1537,7 @@ return PyUnicode_FromWideChar(&c, 1);
 // @snippet return-pyunicode-qchar
 
 // @snippet return-qvariant
+qDebug("return-qvariant %d", %in.typeId());
 if (!%in.isValid())
     Py_RETURN_NONE;
 
@@ -1558,6 +1560,7 @@ case QMetaType::QStringList: {
 }
 case QMetaType::QVariantMap: {
     const auto var = %in.value<QVariantMap>();
+    qDebug("return-qvariant QVariantMap");
     return %CONVERTTOPYTHON[QMap<QString, QVariant>](var);
 }
 default:
diff --git a/sources/pyside6/libpyside/pysidemetafunction.cpp b/sources/pyside6/libpyside/pysidemetafunction.cpp
index eb2943ecf..f4798aad3 100644
--- a/sources/pyside6/libpyside/pysidemetafunction.cpp
+++ b/sources/pyside6/libpyside/pysidemetafunction.cpp
@@ -96,6 +96,7 @@ PySideMetaFunction *newObject(QObject *source, int methodIndex)
 
 bool call(QObject *self, int methodIndex, PyObject *args, PyObject **retVal)
 {
+    qDebug() << __FUNCTION__ << self << methodIndex;
 
     QMetaMethod method = self->metaObject()->method(methodIndex);
     QList<QByteArray> argTypes = method.parameterTypes();
@@ -138,7 +139,9 @@ bool call(QObject *self, int methodIndex, PyObject *args, PyObject **retVal)
         }
 
         Shiboken::Conversions::SpecificConverter converter(typeName);
+        qDebug() << __FUNCTION__ << typeName << "conv=" << converter.isValid();
         if (converter) {
+
             QMetaType metaType = QMetaType::fromName(typeName);
             if (!Shiboken::Conversions::pythonTypeIsObjectType(converter)) {
                 if (!metaType.isValid()) {
diff --git a/sources/pyside6/libpyside/pysidesignal.cpp b/sources/pyside6/libpyside/pysidesignal.cpp
index 7625cb4d6..5c01e9074 100644
--- a/sources/pyside6/libpyside/pysidesignal.cpp
+++ b/sources/pyside6/libpyside/pysidesignal.cpp
@@ -261,6 +261,7 @@ static int signalTpInit(PyObject *obSelf, PyObject *args, PyObject *kwds)
         if (PySequence_Check(arg) && !Shiboken::String::check(arg) && !PyEnumMeta_Check(arg)) {
             tupledArgs = true;
             const auto sig = PySide::Signal::parseSignature(arg);
+//            qDebug() << __FUNCTION__ << "tupled" << sig;
             PySide::Signal::appendSignature(
                         self,
                         PySide::Signal::SignalSignature(sig));
@@ -269,6 +270,7 @@ static int signalTpInit(PyObject *obSelf, PyObject *args, PyObject *kwds)
 
     if (!tupledArgs) {
         const auto sig = PySide::Signal::parseSignature(args);
+//        qDebug() << __FUNCTION__ << sig;
         PySide::Signal::appendSignature(
                     self,
                     PySide::Signal::SignalSignature(sig));
@@ -966,6 +968,7 @@ static QByteArray parseSignature(PyObject *args)
 
 static void appendSignature(PySideSignal *self, const SignalSignature &signature)
 {
+//    qDebug() << __FUNCTION__ << signature.m_parameterTypes << signature.m_attributes;
     self->data->signatures.append({signature.m_parameterTypes, signature.m_attributes});
 }
 
@@ -988,6 +991,7 @@ static void instanceInitialize(PySideSignalInstance *self, PyObject *name, PySid
     selfPvt->source = source;
     const auto &signature = signal->data->signatures.at(index);
     selfPvt->signature = buildSignature(self->d->signalName, signature.signature);
+//    qDebug() << __FUNCTION__ << selfPvt->signature;
     selfPvt->attributes = signature.attributes;
     selfPvt->homonymousMethod = nullptr;
     if (signal->homonymousMethod) {
diff --git a/sources/pyside6/libpyside/signalmanager.cpp b/sources/pyside6/libpyside/signalmanager.cpp
index a5afdd13e..598af5fcb 100644
--- a/sources/pyside6/libpyside/signalmanager.cpp
+++ b/sources/pyside6/libpyside/signalmanager.cpp
@@ -12,6 +12,8 @@
 #include "pysidemetafunction_p.h"
 #include "pysidestaticstrings.h"
 
+#include <helper.h>
+
 #include <autodecref.h>
 #include <basewrapper.h>
 #include <bindingmanager.h>
@@ -27,6 +29,7 @@
 #include <QtCore/QScopedPointer>
 
 #include <algorithm>
+#include <iostream>
 #include <limits>
 #include <memory>
 
@@ -367,6 +370,7 @@ int SignalManager::globalReceiverSlotIndex(QObject *receiver, const char *signat
 
 bool SignalManager::emitSignal(QObject *source, const char *signal, PyObject *args)
 {
+    qDebug() << __FUNCTION__ << source << signal;
     if (!Signal::checkQtSignal(signal))
         return false;
     signal++;
@@ -535,6 +539,7 @@ int SignalManager::qt_metacall(QObject *object, QMetaObject::Call call, int id,
 
 int SignalManager::callPythonMetaMethod(const QMetaMethod &method, void **args, PyObject *pyMethod, bool isShortCuit)
 {
+    qDebug() << __FUNCTION__ << method.methodSignature() << "isShortCuit=" << isShortCuit;
     Q_ASSERT(pyMethod);
 
     Shiboken::GilState gil;
@@ -545,6 +550,7 @@ int SignalManager::callPythonMetaMethod(const QMetaMethod &method, void **args,
     } else {
         pyArguments = parseArguments(method.parameterTypes(), args);
     }
+    std::cerr << "pyArguments=" << Shiboken::debugPyObject(pyArguments) << '\n';
 
     if (pyArguments) {
         QScopedPointer<Shiboken::Conversions::SpecificConverter> retConverter;
@@ -713,7 +719,7 @@ static PyObject *parseArguments(const QList<QByteArray>& paramTypes, void **args
 {
     const qsizetype argsSize = paramTypes.size();
     PyObject *preparedArgs = PyTuple_New(argsSize);
-
+    qDebug() << __FUNCTION__ << paramTypes;
     for (qsizetype i = 0; i < argsSize; ++i) {
         void *data = args[i+1];
         const char *dataType = paramTypes[i].constData();
@@ -732,6 +738,7 @@ static PyObject *parseArguments(const QList<QByteArray>& paramTypes, void **args
 static bool emitShortCircuitSignal(QObject *source, int signalIndex, PyObject *args)
 {
     void *signalArgs[2] = {nullptr, args};
+    qDebug() << __FUNCTION__ << source << signalIndex;
     source->qt_metacall(QMetaObject::InvokeMetaMethod, signalIndex, signalArgs);
     return true;
 }