diff --git a/sources/pyside6/libpyside/dynamicqmetaobject.cpp b/sources/pyside6/libpyside/dynamicqmetaobject.cpp
index a3a16b6a0..a7fbbfcb3 100644
--- a/sources/pyside6/libpyside/dynamicqmetaobject.cpp
+++ b/sources/pyside6/libpyside/dynamicqmetaobject.cpp
@@ -86,6 +86,7 @@ QMetaObjectBuilder *MetaObjectBuilderPrivate::ensureBuilder()
 MetaObjectBuilder::MetaObjectBuilder(const char *className, const QMetaObject *metaObject) :
     m_d(new MetaObjectBuilderPrivate)
 {
+    qDebug() << __FUNCTION__ << "className=" << className << "mo=" << metaObject->className();
     m_d->m_baseObject = metaObject;
     m_d->m_builder = new QMetaObjectBuilder();
     m_d->m_builder->setClassName(className);
diff --git a/sources/pyside6/libpyside/globalreceiverv2.cpp b/sources/pyside6/libpyside/globalreceiverv2.cpp
index 301d7c535..d6113062b 100644
--- a/sources/pyside6/libpyside/globalreceiverv2.cpp
+++ b/sources/pyside6/libpyside/globalreceiverv2.cpp
@@ -192,6 +192,7 @@ GlobalReceiverV2::GlobalReceiverV2(PyObject *callback, QObject *receiver) :
     m_receiver(receiver)
 {
     m_data = new DynamicSlotDataV2(callback, this);
+    qDebug() << __FUNCTION__ << m_data;
 }
 
 GlobalReceiverV2::~GlobalReceiverV2()
@@ -212,7 +213,10 @@ GlobalReceiverV2::~GlobalReceiverV2()
 
 int GlobalReceiverV2::addSlot(const char *signature)
 {
-    return m_data->addSlot(signature);
+    qDebug() << "GlobalReceiverV2::addSlot" << this << '"' << signature << '"';
+    int x = m_data->addSlot(signature);
+    qDebug() << "GlobalReceiverV2::addSlot" << x << m_data;
+    return x;
 }
 
 void GlobalReceiverV2::incRef(const QObject *link)
diff --git a/sources/pyside6/libpyside/pysidemetafunction.cpp b/sources/pyside6/libpyside/pysidemetafunction.cpp
index eb2943ecf..a6a919a47 100644
--- a/sources/pyside6/libpyside/pysidemetafunction.cpp
+++ b/sources/pyside6/libpyside/pysidemetafunction.cpp
@@ -96,7 +96,7 @@ PySideMetaFunction *newObject(QObject *source, int methodIndex)
 
 bool call(QObject *self, int methodIndex, PyObject *args, PyObject **retVal)
 {
-
+    qDebug() << __FUNCTION__ << methodIndex;
     QMetaMethod method = self->metaObject()->method(methodIndex);
     QList<QByteArray> argTypes = method.parameterTypes();
 
diff --git a/sources/pyside6/libpyside/qobjectconnect.cpp b/sources/pyside6/libpyside/qobjectconnect.cpp
index de6f74b14..aab35cb2c 100644
--- a/sources/pyside6/libpyside/qobjectconnect.cpp
+++ b/sources/pyside6/libpyside/qobjectconnect.cpp
@@ -9,6 +9,7 @@
 
 #include "shiboken.h"
 #include "basewrapper.h"
+#include "helper.h"
 #include "autodecref.h"
 
 #include <QtCore/QDebug>
@@ -16,6 +17,7 @@
 #include <QtCore/QObject>
 
 #include <string_view>
+#include <iostream>
 
 static bool isMethodDecorator(PyObject *method, bool is_pymethod, PyObject *self)
 {
@@ -94,6 +96,8 @@ static GetReceiverResult getReceiver(QObject *source, const char *signal,
                                      PyObject *callback)
 {
     GetReceiverResult result;
+    qDebug() << __FUNCTION__ << source << signal;
+    std::cerr << "callback= " << Shiboken::debugPyObject(callback) << '\n';
 
     bool forceGlobalReceiver = false;
     if (PyMethod_Check(callback)) {
@@ -158,7 +162,7 @@ static GetReceiverResult getReceiver(QObject *source, const char *signal,
         const QMetaObject *metaObject = result.receiver->metaObject();
         result.slotIndex = metaObject->indexOfSlot(result.callbackSig.constData());
     }
-
+    qDebug() << __FUNCTION__ << "rets" << result;
     return result;
 }
 
@@ -175,6 +179,8 @@ QMetaObject::Connection qobjectConnect(QObject *source, const char *signal,
                                        QObject *receiver, const char *slot,
                                        Qt::ConnectionType type)
 {
+    qDebug() << __FUNCTION__ << source << '"' << signal << '"'
+             << receiver << '"' << slot << '"' << type;
     if (!signal || !slot || !PySide::Signal::checkQtSignal(signal))
         return {};
 
@@ -198,6 +204,7 @@ QMetaObject::Connection qobjectConnect(QObject *source, QMetaMethod signal,
 QMetaObject::Connection qobjectConnectCallback(QObject *source, const char *signal,
                                                PyObject *callback, Qt::ConnectionType type)
 {
+    qDebug() << __FUNCTION__ << source << '"' << signal << '"' << type;
     if (!signal || !PySide::Signal::checkQtSignal(signal))
         return {};
 
@@ -231,6 +238,7 @@ QMetaObject::Connection qobjectConnectCallback(QObject *source, const char *sign
             : PySide::SignalManager::registerMetaMethodGetIndex(receiver.receiver, slotSignature,
                                                                 QMetaMethod::Slot);
 
+        qDebug() << __FUNCTION__ << "slotIndex=" << slotIndex;
         if (slotIndex == -1) {
             if (receiver.usingGlobalReceiver)
                 signalManager.releaseGlobalReceiver(source, receiver.receiver);
@@ -240,6 +248,7 @@ QMetaObject::Connection qobjectConnectCallback(QObject *source, const char *sign
     }
 
     auto connection = QMetaObject::connect(source, signalIndex, receiver.receiver, slotIndex, type);
+    qDebug() << __FUNCTION__ << "connection=" << connection;
     if (!connection) {
         if (receiver.usingGlobalReceiver)
             signalManager.releaseGlobalReceiver(source, receiver.receiver);
diff --git a/sources/pyside6/libpyside/signalmanager.cpp b/sources/pyside6/libpyside/signalmanager.cpp
index a5afdd13e..e1c1db69b 100644
--- a/sources/pyside6/libpyside/signalmanager.cpp
+++ b/sources/pyside6/libpyside/signalmanager.cpp
@@ -362,11 +362,15 @@ void SignalManager::SignalManagerPrivate::purgeEmptyGobalReceivers()
 
 int SignalManager::globalReceiverSlotIndex(QObject *receiver, const char *signature) const
 {
-    return static_cast<GlobalReceiverV2 *>(receiver)->addSlot(signature);
+    qDebug() << "SignalManager::globalReceiverSlotIndex" << receiver << signature;
+    int x = static_cast<GlobalReceiverV2 *>(receiver)->addSlot(signature);
+    qDebug() << "SignalManager::globalReceiverSlotIndex" << x;
+    return x;
 }
 
 bool SignalManager::emitSignal(QObject *source, const char *signal, PyObject *args)
 {
+    qDebug() << "\n-----SignalManager::emitSignal" << source << signal;
     if (!Signal::checkQtSignal(signal))
         return false;
     signal++;
@@ -377,6 +381,7 @@ bool SignalManager::emitSignal(QObject *source, const char *signal, PyObject *ar
         // if the signature doesn't have a '(' it's a shor circuited signal, i.e. std::find
         // returned the string null terminator.
         bool isShortCircuit = !*std::find(signal, signal + std::strlen(signal), '(');
+        qDebug() << " SignalManager::emitSignal isShortCircuit=" << isShortCircuit;
         return isShortCircuit
             ? emitShortCircuitSignal(source, signalIndex, args)
             : MetaFunction::call(source, signalIndex, args);
@@ -534,8 +539,11 @@ int SignalManager::qt_metacall(QObject *object, QMetaObject::Call call, int id,
 }
 
 int SignalManager::callPythonMetaMethod(const QMetaMethod &method, void **args, PyObject *pyMethod, bool isShortCuit)
-{
+{    
     Q_ASSERT(pyMethod);
+    qDebug() << " SignalManager::callPythonMetaMethod" << method.methodSignature()
+             << "pyMethod=" << pyMethod
+             << "isShortCuit=" << isShortCuit;
 
     Shiboken::GilState gil;
     PyObject *pyArguments = nullptr;
@@ -558,6 +566,7 @@ int SignalManager::callPythonMetaMethod(const QMetaMethod &method, void **args,
         }
 
         Shiboken::AutoDecRef retval(PyObject_CallObject(pyMethod, pyArguments));
+        qDebug() << " SignalManager::callPythonMetaMethod" << "PyObject_CallObject" << retval.object();
 
         if (!isShortCuit && pyArguments){
             Py_DECREF(pyArguments);
@@ -574,6 +583,7 @@ int SignalManager::callPythonMetaMethod(const QMetaMethod &method, void **args,
 bool SignalManager::registerMetaMethod(QObject *source, const char *signature, QMetaMethod::MethodType type)
 {
     int ret = registerMetaMethodGetIndex(source, signature, type);
+    qDebug() << " SignalManager::registerMetaMethod" << source << signature << type;
     return (ret != -1);
 }
 
@@ -648,6 +658,7 @@ QDebug operator<<(QDebug debug, const slotSignature &sig)
 
 int SignalManager::registerMetaMethodGetIndex(QObject *source, const char *signature, QMetaMethod::MethodType type)
 {
+    qDebug() << "SignalManager::registerMetaMethodGetIndex()" << source << signature << type;
     if (!source) {
         qWarning("SignalManager::registerMetaMethodGetIndex(\"%s\") called with source=nullptr.",
                  signature);
@@ -655,6 +666,7 @@ int SignalManager::registerMetaMethodGetIndex(QObject *source, const char *signa
     }
     const QMetaObject *metaObject = source->metaObject();
     int methodIndex = metaObject->indexOfMethod(signature);
+    qDebug() << __FUNCTION__ << "SignalManager::registerMetaMethodGetIndex() 1st methodIndex=" << methodIndex;
     // Create the dynamic signal is needed
     if (methodIndex == -1) {
         SbkObject *self = Shiboken::BindingManager::instance().retrieveWrapper(source);
@@ -680,10 +692,12 @@ int SignalManager::registerMetaMethodGetIndex(QObject *source, const char *signa
                 << signature << "\" on " << source->metaObject()->className()
                 << ". Consider annotating with " << slotSignature(signature);
         }
+        qDebug() << "SignalManager::registerMetaMethodGetIndex() ADDING" <<  signature;
 
         return type == QMetaMethod::Signal
             ? dmo->addSignal(signature) : dmo->addSlot(signature);
     }
+    qDebug() << "SignalManager::registerMetaMethodGetIndex() rets" <<  signature << methodIndex;
     return methodIndex;
 }
 
@@ -731,6 +745,7 @@ static PyObject *parseArguments(const QList<QByteArray>& paramTypes, void **args
 
 static bool emitShortCircuitSignal(QObject *source, int signalIndex, PyObject *args)
 {
+    qDebug() << "emitShortCircuitSignal" << source << signalIndex;
     void *signalArgs[2] = {nullptr, args};
     source->qt_metacall(QMetaObject::InvokeMetaMethod, signalIndex, signalArgs);
     return true;